#ifndef INVERSE_H_INCLUDED
#define INVERSE_H_INCLUDED

#include "types.h"
#include "large_math.h"

class INVERSE_MODULO
{
u32 len;    

SIGNED_MULTI_DIV *sdiv;
SIGNED_MULTI_MUL *smul;

u32 *x[3];
u32 *y[3];
u32 *r[3];

u32 *quotient;
u32 *prod;


public:
    INVERSE_MODULO(u32 length_x32);
    ~INVERSE_MODULO();
    int inverse(u32 *g_, u32 const* g, u32 const* p);
    void reset();
};

#endif

