#ifndef PKF_H
#define PKF_H

#include "types.h"

class PKF
 {
 u32 *pkf_mem;
 void init();
 u32 mix(u32 *crc, const u32 x);
 s64 inverse(const s64 modulo, s64 value);

public:
 
 PKF();
 ~PKF();
 void get_key(void *key,const u32 key_size_bytes, 
              void const *salt, const u32 salt_size_bytes,  
              void const *passwd, const u32 passwd_size_bytes);
 };

#endif

